
#ifndef VALUE_EXPRESSION_LOGICAL_TEMPLATES
#define VALUE_EXPRESSION_LOGICAL_TEMPLATES

template <class Op>
Foam::volScalarField *ValueExpressionDriver::doCompare(Foam::volScalarField *a,Op op,Foam::volScalarField *b)
{
    Foam::volScalarField *res=makeScalarField(0.);

    forAll(*res,cellI) {
        if( op((*a)[cellI],(*b)[cellI]) ) {
            (*res)[cellI]=1;
        } else {
            (*res)[cellI]=0;
        }
    }

    return res;
}

template <class Op>
Foam::volScalarField *ValueExpressionDriver::doLogicalOp(Foam::volScalarField *a,Op op,Foam::volScalarField *b)
{
    Foam::volScalarField *res=makeScalarField(0.);

    forAll(*res,cellI) {
        bool av= (*a)[cellI] ? true : false;
        bool bv= (*b)[cellI] ? true : false;

        if( op(av,bv) ) {
            (*res)[cellI]=1;
        } else {
            (*res)[cellI]=0;
        }
    }

    return res;
}

template <class T>
T * ValueExpressionDriver::doConditional(Foam::volScalarField *cond,T* yes,T* no,T* result)
{
    forAll(*result,cellI) {
        bool c= (*cond)[cellI] ? true : false;
        if(c) {
            (*result)[cellI]=(*yes)[cellI];
        } else {
            (*result)[cellI]=(*no)[cellI];
        }
    }

    return result;
}

#endif
